///
PUT /users
{
    "mappings": {
        "properties": {
            "Title": {
                "type": "string",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            }
        }
    }
}
// فیلد های داخلی فیلد هایی هستن زیر مجموعه فیلد های دیگر
// فیلد های داخلی خودشان بر اساس فیلد اصلی پر میشوند

// فیلد keyword میشود نوع کیورد فیلد اصلی نت برای بعضی حالات به کار رود
// ignore_above -> تعدادی از فیلد اصلی، یعنی فیلد اصلی هر چقدر بود، ignore_above تاشو بردار و به عنوان کیورد ذخیره کن
// برای دسترسی به این فیلد -> Title.keyword
// اگر کل متنتان را میخواهید به عنوان قابلیت های keyword نیز استفاده کنید، نیازی به تعریف فیلد keyword نیست
// میتوانید کد زیر را بنویسید
// "Title": {
// "type": "string",
// "fielddata": true
// }

Put /users
{
    "mappings": {
        "properties": {
            "subject": {
                "properties": {
                    "id": {
                        "type": "integer"
                    },
                    "title": {
                        "type": "text",
                        "fielddata": true
                    }
                }
            }
        }
    }
}
// در این ایندکس فیلد یک تایپ مشخص نیست، بلکه یک object است
// برای خود فیلد میتوانید پراپرتیس تعریف نمایید که مانند Title,keyword استفاده میشود
// حالا میتوانید از subject.id و subject.title استفاده کنید