// یک نمونه واقعی و عملی از mapping

PUT /crawl-details
{
    "mappings": {
        "properties": {
            "id": {
                "type": "keyword"
            },
            "person_code": {
                "type": "keyword"
            },
            "research_code": {
                "type": "keyword"
            },
            "meet_code": {
                "type": "keyword"
            },
            "Allwords": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "author": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "branch": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "title": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "meet_no": {
                "type": "integer"
            },
            "subject": {
                "properties": {
                    "id": {
                        "type": "integer"
                    },
                    "title": {
                        "type": "text",
                        "fielddata": true,
                        "fields": {
                            "keyword": {
                                "type": "keyword",
                                "ignore_above": 256
                            }
                        }
                    }
                }
            },
            "subtitle": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "tags": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "keywords": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "verb": {
                "type": "text",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "format": {
                "type": "text",
                "fielddata": true,
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 256
                    }
                }
            },
            "begin_year": {
                "type": "integer",
                "fields": {
                    "keyword": {
                        "type": "keyword",
                        "ignore_above": 20
                    }
                }
            },
            "begin_date": {
                "type": "keyword"
            },
            "end_date": {
                "type": "keyword"
            },
            "amplify": {
                "type": "text"
            },
            "ralation": {
                "type": "keyword"
            },
            "city": {
                "type": "keyword"
            },
            "place": {
                "type": "keyword"
            },
            "address": {
                "type": "text"
            },
            "films": {
                "type": "integer"
            },
            "voices": {
                "type": "integer"
            },
            "photos": {
                "type": "integer"
            },
            "audience": {
                "type": "text",
                "fielddata": true
            },
            "attendees": {
                "type": "text"
            }
        }
    }
}