<div align="JUSTIFY" dir="rtl">
<p align="center" dir="rtl">بسم الله الرحمن الرحیم</p>

<p align="center">
  <img src="img/index.png" />
</p>

تحلیلگرهای جستجوی فهرست و منابع آنها را دوباره بارگیری می کند. برای جریان‌های داده، API تحلیلگرهای جستجو و منابع شاخص‌های پشتیبان جریان را دوباره بارگیری می‌کند.

<div align="left" dir="ltr" style="background-color:black;">

```json
POST /my-index-000001/_reload_search_analyzers
POST /my-index-000001/_cache/clear?request=true
```

</div>

پس از بارگیری مجدد تحلیلگرهای جستجو، باید کش درخواست را پاک کنید تا مطمئن شوید که حاوی پاسخ های مشتق شده از نسخه های قبلی تحلیلگر نیست.

## درخواست:

<div align="left" dir="ltr" style="background-color:black;">

```json
POST /<target>/_reload_search_analyzers

GET /<target>/_reload_search_analyzers
```

</div>

## :پیش نیازها

اگر ویژگی‌های امنیتی Elasticsearch فعال هستند، باید امتیاز مدیریت فهرست را برای جریان داده، فهرست یا نام مستعار هدف داشته باشید.

توضیح:
می‌توانید از API تحلیل‌گرهای جستجوی بارگذاری مجدد برای دریافت تغییرات فایل‌های مترادف استفاده شده در مترادف_گراف یا فیلتر نشانه مترادف یک تحلیلگر جستجو استفاده کنید. برای واجد شرایط بودن، فیلتر توکن باید دارای یک پرچم قابل به روز رسانی درست باشد و فقط در تحلیلگرهای جستجو استفاده شود.

### نکته:

این API برای هر قطعه از یک شاخص بارگذاری مجدد انجام نمی دهد. در عوض، بارگذاری مجدد را برای هر گره حاوی خرده های شاخص انجام می دهد. در نتیجه، تعداد کل خرده‌های بازگردانده شده توسط API می‌تواند با تعداد خرده‌های شاخص متفاوت باشد.

از آنجایی که بارگذاری مجدد بر هر گره دارای یک قطعه شاخص تأثیر می گذارد، مهم است که قبل از استفاده از این API، فایل مترادف را در هر گره داده در خوشه، از جمله گره هایی که حاوی ماکت قطعه نیستند، به روز کنید. این تضمین می‌کند که فایل مترادف در همه جای خوشه به‌روزرسانی می‌شود تا در صورت جابجایی خرده‌ها در آینده.

## پارامترهای مسیر

<target>

(Required, string) فهرستی از جریان‌های داده، شاخص‌ها و نام‌های مستعار جدا شده با کاما برای محدود کردن درخواست. از حروف عام (_) پشتیبانی می کند. برای هدف قرار دادن تمام جریان‌ها و شاخص‌های داده، از _ یا \_all استفاده کنید.

Query پارامترهای:

allow_no_indices :

-   (Optional, Boolean) اگر false باشد، اگر هر عبارت عام، نام مستعار نمایه یا \_all فقط شاخص‌های بسته یا گم شده باشد، درخواست خطا برمی‌گرداند. این رفتار حتی اگر درخواست سایر شاخص های باز را هدف قرار دهد اعمال می شود. به عنوان مثال، درخواستی که foo*,bar* را هدف قرار می دهد، اگر فهرستی با foo شروع شود اما هیچ فهرستی با نوار شروع نشده باشد، خطایی را برمی گرداند.

-   پیش فرض true است.

expand_wildcards:

-   (Optional, string)نوع شاخصی که الگوهای عام می توانند مطابقت داشته باشند. اگر درخواست بتواند جریان های داده را هدف قرار دهد، این آرگومان تعیین می کند که آیا عبارات عبارات با جریان داده های پنهان مطابقت دارند یا خیر. از مقادیر جدا شده با کاما مانند open,hidden پشتیبانی می کند. مقادیر معتبر عبارتند از:

-   all
    هر جریان یا شاخص داده، از جمله موارد پنهان را مطابقت دهید.
-   open
    با شاخص های باز و غیر پنهان مطابقت دهید. همچنین با هر جریان داده غیر پنهانی مطابقت دارد.
-   closed
    مطابقت با شاخص های بسته و غیر پنهان. همچنین با هر جریان داده غیر پنهانی مطابقت دارد. جریان های داده را نمی توان بسته کرد.
-   hidden
    جریان های داده های پنهان و شاخص های پنهان را مطابقت دهید. باید با open, closed, یا هردو باشد.
-   none
    الگوهای عامیانه پذیرفته نمی شوند.

-   پیش فرض open است.

ignore_unavailable:

-   (Optional, Boolean) اگر false باشد، درخواست اگر نمایه گمشده یا بسته را هدف قرار دهد، یک خطا برمی‌گرداند. پیش فرض به false.

مثال ها
از[ ایجاد API شاخص](https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-create-index.html) برای ایجاد یک فهرست با یک تحلیلگر جستجو استفاده کنید که حاوی فیلتر مترادف قابل به روز رسانی است.

استفاده از analyzer زیر به عنوان analyzer index منجر به خطا می شود.

<div align="left" dir="ltr" style="background-color:black;">

```json
PUT /my-index-000001
{
  "settings": {
    "index": {
      "analysis": {
        "analyzer": {
          "my_synonyms": {
            "tokenizer": "whitespace",
            "filter": [ "synonym" ]
          }
        },
        "filter": {
          "synonym": {
            "type": "synonym_graph",
            "synonyms_path": "analysis/synonym.txt",
            "updateable": true
          }
        }
      }
    }
  },
  "mappings": {
    "properties": {
      "text": {
        "type": "text",
        "analyzer": "standard",
        "search_analyzer": "my_synonyms"
      }
    }
  }
}
```

</div>

-   شا\*مل یک فایل مترادف است.
-   فیلتر توکن را به‌عنوان قابل به‌روزرسانی علامت‌گذاری می‌کند.
-   آنالیزور را به عنوان تحلیلگر جستجو علامت گذاری می کند.

پس از به روز رسانی فایل مترادف، از [API بارگذاری مجدد تحلیلگر](https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-reload-analyzers.html) برای بارگیری مجدد تحلیلگر جستجو و دریافت تغییرات فایل استفاده کنید.

<div align="left" dir="ltr" style="background-color:black;">

```json
POST /my-index-000001/\_reload_search_analyzers

```

</div>

API پاسخ زیر را برمی گرداند.

<div align="left" dir="ltr" style="background-color:black;">

```json
{
    "_shards": {
        "total": 2,
        "successful": 2,
        "failed": 0
    },
    "reload_details": [
        {
            "index": "my-index-000001",
            "reloaded_analyzers": ["my_synonyms"],
            "reloaded_node_ids": ["mfdqTXn_T7SGr2Ho2KT8uw"]
        }
    ]
}
```

</div>

[منبع](https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-reload-analyzers.html#indices-reload-analyzers)

<p align="center" dir="rtl">صلوات</p>
</div>
