# Elasticsearch

[README انگلیسی در اینجا](./README.md)

+ جستجوی متنی کامل: Elasticsearch قابلیت جستجوی پیشرفته متنی را فراهم می‌کند، به شما امکان می‌دهد بر اساس مطابقت متنی و امتیازدهی به مطابقت، سند‌های مرتبط را جستجو و بازیابی کنید.

+ توزیع‌شده و قابل مقیاس: Elasticsearch برای توزیع و قابل مقیاس بودن طراحی شده است، به شما امکان می‌دهد حجم بزرگی از داده را در سرورها و خوشه‌های متعدد ذخیره و پردازش کنید.
+ داده نزدیک به زمان واقعی: Elasticsearch قابلیت نزدیک به زمان واقعی برای فرایند ایندکس‌گذاری و جستجو را فراهم می‌کند، به شما اجازه می‌دهد تقریباً به صورت فوری داده را ایندکس و جستجو کنید.
+ محورمند به سند: Elasticsearch داده را به عنوان سند‌های ساختارمند JSON در نظر می‌گیرد، که این امکان را برای شما فراهم می‌کند که انواع مختلفی از داده را ایندکس، جستجو و تجزیه و تحلیل کنید.
+ چند‌مستندی: Elasticsearch از چند‌مستندی پشتیبانی می‌کند، به شما امکان می‌دهد داده‌ها را از کاربران یا برنامه‌های مختلف در یک خوشه‌ مشخص جدا کنید و امنیت ببخشید.
+ تجزیه و تحلیل و آمارها: Elasticsearch قابلیت تجزیه و تحلیل قدرتمند برای انجام آمار و تحلیل بر روی داده‌هایتان را فراهم می‌کند، این قابلیت به شما امکان استخراج بینش‌ها و خلاصه‌سازی داده را در ابعاد مختلف می‌دهد.
+ بدون نیاز به طرح شمایی: Elasticsearch بدون نیاز به طرح شمایی است، به این معنی که می‌توانید داده را بدون تعریف پیش‌فرض طرح شما در آن ایندکس، جستجو و مدیریت کنید. این انعطاف‌پذیری به شما امکان تطبیق آسان با ساختارهای داده‌ای متغیر را می‌دهد.
+ رابط برنامه نویسی RESTful: Elasticsearch رابط برنامه نویسی RESTful را ارائه می‌دهد، که به راحتی می‌توانید با سیستم تعامل کنید و عملیات‌های مختلف مانند ایندکس
‌گذاری، جستجو و مدیریت داده را انجام دهید.
+ جستجوی توزیع‌شده: Elasticsearch به شما امکان می‌دهد عملیات جستجو را در سرورهای متعدد توزیع کنید، این امکان را فراهم می‌کند که پردازش‌های موازی و عملکرد جستجوی سریع‌تری را داشته باشید.
+ ادغام با اکوسیستم: Elasticsearch ادغام خوبی با ابزارها و فناوری‌های دیگر دارد، مانند Logstash و Kibana، که با هم تشکیل پکیج ELK (Elasticsearch، Logstash و Kibana) را برای تحلیل و نظارت بر لاگ‌ها ایجاد می‌کنند.


## اطلاعات:
ورژن فعلی: 8.8<br>
وب سایت: https://elastic.co<br>
لینک دانلود ورژن 8.8: https://artifacts.elastic.co/downloads/elasticsearch/elasticsearch-8.8.2-windows-x86_64.zip<br>
لینک دانلود ورژن 7.17: https://artifacts.elastic.co/downloads/elasticsearch/elasticsearch-7.17.11-windows-x86_64.zip


## دانلود
[راهنمای دانلود فارسی](./Install-fa.md)<br>
[راهنمای دانلود انگلیسی](./Install.md)<br>

## استفاده
``` json
    DELETE /firstindex

    // Delet a Index


    DELETE /firstindex/_doc/1

    // Delet a doc by id of the Index




    // GET
    GET /firstindex/_doc/0

    // Get Index By Id 0


    GET firstindex/_count

    // تعداد doc ها در ایندکس




    // POST
    POST firstindex/_doc/1
    {
        "name": "Ali",
        "age": 23
    }
    // Insert Into doc by id 1

    POST firstindex/_doc
    {
        "name": "Ali",
        "age": 23
    }
    // Insert Into new DOC

    POST /firstindex/_delete_by_query
    {
        "query": {
            "match_all": {}
        }
    }
    // Delete all

    POST /firstindex/_delete_by_query
    {
        "query": {
            "match": {
                "_id": "v8eA2IQB5pIgH4LhE2mX"
        }
    }
    }
    // Delete doc By id







    // Querys
    // Example: POST /firstindex/_delete_by_query{"Query"}
    //         
    {
        "query": {
        "match_all": {}
        }
    }
    // All


```


## مسیر یادگیری

توضیحات وب
_ [نصب کیبانا](https://www.elastic.co/guide/en/kibana/current/windows.html)<br>
_ [ساخت ایندکس](https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-create-index.html)<br>
_ [حذف ایندکس](https://www.elastic.co/guide/en/elasticsearch/reference/current/indices-delete-index.html)<br>
_ [گرفتن ایندکس](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-get.html)<br>
_ [افزودن در ایندکس](https://kb.objectrocket.com/elasticsearch/guide-how-to-add-documents-to-an-index-in-elasticsearch)<br>
_ [داکیومنتیشن](https://www.elastic.co/guide/index.html)<br>