# result discussion

```
Code: 
    PUT /firstindex

Result: 
    "acknowledged": true,
    "shards_acknowledged": true,
    "index": "firstindex"
```
+ acknowledged: To be successful or not
+ shards_acknowledged: The success or failure of certain sections
+ index: index name

---

```
Code: 
    PUT /firstindex

Result: 
    {
    "error": {
        "root_cause": [
            {
                "type": "resource_already_exists_exception",
                "reason": "index [firstindex/mctRe4VYTs28SWLGZ4hEiQ] already exists",
                "index_uuid": "mctRe4VYTs28SWLGZ4hEiQ",
                "index": "firstindex"
            }
        ],
        "type": "resource_already_exists_exception",
        "reason": "index [firstindex/mctRe4VYTs28SWLGZ4hEiQ] already exists",
        "index_uuid": "mctRe4VYTs28SWLGZ4hEiQ",
        "index": "firstindex"
    },
    "status": 400
}
```
meaning: index already exists

---

```
Code: 
   Delete /users/_doc/0313123

Result: 
   {
    "error": {
        "root_cause": [
            {
                "type": "index_not_found_exception",
                "reason": "no such index [users]",
                "resource.type": "index_expression",
                "resource.id": "users",
                "index_uuid": "_na_",
                "index": "users"
            }
        ],
        "type": "index_not_found_exception",
        "reason": "no such index [users]",
        "resource.type": "index_expression",
        "resource.id": "users",
        "index_uuid": "_na_",
        "index": "users"
    },
    "status": 404
}
```
meaning: This id is not exists

---

```
Code:
    Delete /Index

Result: 
    {
    "error": {
        "root_cause": [
            {
                "type": "index_not_found_exception",
                "reason": "no such index [firsftindex]",
                "resource.type": "index_or_alias",
                "resource.id": "firsftindex",
                "index_uuid": "_na_",
                "index": "firsftindex"
            }
        ],
        "type": "index_not_found_exception",
        "reason": "no such index [firsftindex]",
        "resource.type": "index_or_alias",
        "resource.id": "firsftindex",
        "index_uuid": "_na_",
        "index": "firsftindex"
    },
    "status": 404
}
```
meaning: This Index is not exists

---

```
Code: 
   Delete /users/_doc/0313123

Result: 
   {
    "error": {
        "root_cause": [
            {
                "type": "index_not_found_exception",
                "reason": "no such index [users]",
                "resource.type": "index_expression",
                "resource.id": "users",
                "index_uuid": "_na_",
                "index": "users"
            }
        ],
        "type": "index_not_found_exception",
        "reason": "no such index [users]",
        "resource.type": "index_expression",
        "resource.id": "users",
        "index_uuid": "_na_",
        "index": "users"
    },
    "status": 404
}
```
meaning: This id is not exists

---

```
Code:
    GET _tasks/1

Result: 
   {
    "error": {
        "root_cause": [
            {
                "type": "illegal_argument_exception",
                "reason": "malformed task id 1"
            }
        ],
        "type": "illegal_argument_exception",
        "reason": "malformed task id 1"
    },
    "status": 400
}
```
meaning: This task id is not exists